import requests
from Crypto.Hash import keccak
from urlextract import URLExtract
from pathlib import Path
import sqlite3
import concurrent.futures
import pandas as pd
import os,subprocess
import boto3 
import time
import sitemap_parser
import traceback
import dump_in_s3

lam = boto3.client(
    service_name='lambda',
    aws_access_key_id="AKIAIVHK5FXF7J3LTA2Q",
    aws_secret_access_key="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",
    region_name = "eu-central-1",
    use_ssl=True
    )

global latest_news_file
latest_news_file = pd.read_csv("latest_news.csv")

def fun_sitemap(i):
    global latest_news_file
    try:
        source_name = latest_news_file.at[i,'name']
        latest_urls = eval(latest_news_file.at[i,'latest_endpoints'])
        requiredParsing = eval(latest_news_file.at[i,'requiredParsing'])
        headers = eval(latest_news_file.at[i,'headers'])
        timeStamps = eval(latest_news_file.at[i,'timestamp'])
        # print(source_name)
        if (Path.cwd() / source_name).exists() == False:
            (Path.cwd() / source_name).mkdir()

        for idx,i_ in enumerate(latest_urls):
            time.sleep(4)
            if (Path.cwd() / source_name / str(idx)).exists() == False:
                (Path.cwd() / source_name / str(idx)).mkdir()
                (Path.cwd() / source_name / str(idx) / 'cache_xml.txt').touch()
                with open(Path.cwd() / source_name / str(idx) / 'cache_xml.txt','w') as f:
                    f.write('0\n{0}')

            
            cache_xml = Path.cwd() / source_name / str(idx) / 'cache_xml.txt'

            if (Path.cwd() / source_name / str(idx) / 'new_urls.db').exists() == False:
                connection = sqlite3.connect(str(Path.cwd() / source_name / str(idx) / 'new_urls.db'),check_same_thread=False,timeout=10)
                cursor = connection.cursor()
                command = '''CREATE TABLE IF NOT EXISTS new_urls (url text primary key, ts TIMESTAMP DEFAULT CURRENT_TIMESTAMP)'''
                cursor.execute(command)
                connection.close()

            # print(i_)
            if requiredParsing[idx] == 1:
                i_ = sitemap_parser.url_parser(i_)
            # print(i_)
            re = requests.get(i_ ,headers=headers[idx],timeout=20)
            response_content = re.content
            if re.status_code in [403,500,502]:
                payload = f'''{{
                            "url": "{i_}",
                            "headers":"{headers[idx]}"
                            }}'''.encode('utf-8')

                response = lam.invoke(
                                        FunctionName='test',
                                        InvocationType='RequestResponse',
                                        Payload = payload
                                    )
                response_content = response['Payload'].read()
            with open(f'current_{source_name}.txt','wb') as f:
                f.write(str(i_+'\n').encode('utf-8'))
                f.write(str(str(headers[idx])+'\n').encode('utf-8'))
                f.write(response_content)
            # print(re.status_code)
            current_urls, t = sitemap_parser.xml_parser(response_content,timeStamps[idx])
            timeStamps[idx] = t
            print(i_,timeStamps[idx])

            
            new_urls = set(current_urls)
            with open(f'{source_name}/{idx}/new_urls.txt','w') as g:
                g.write(str(new_urls))


            try:
                with open(f'{source_name}/{idx}/new_urls.txt','r') as g:
                    previous_urls = eval(g.read())
                    new_urls = new_urls - new_urls.intersection(previous_urls)
            except FileNotFoundError:
                pass
            
            with open(f'count.txt','a+') as g:
                g.write(i_+' ')
                g.write(str(len(new_urls))+'\n')

            if len(new_urls) != 0:
                
                # change
                dump_in_s3.dump_in_s3(source_name=source_name,
                                      site=i_,
                                      new_urls_set=new_urls)
                # change

            connection = sqlite3.connect(str(Path.cwd() / source_name / str(idx) / 'new_urls.db'),check_same_thread=False,timeout=10)
            cursor = connection.cursor()
            for n_u in list(new_urls):
                try:
                    cursor.execute(f'INSERT INTO new_urls(url) VALUES ("{n_u}")')
                except:
                    pass
            connection.commit()                    

            latest_news_file.at[i,'timestamp'] = str(timeStamps)
            print(timeStamps)            
            with open(cache_xml,'w') as f:
                f.write(response_content.decode('utf-8'))

        return (i,timeStamps)

        
    except Exception as exp:
        # print("Error Occurred.")
        with open(f'error_sitemaps.txt','a+') as g:
            g.write(source_name+'\n')
            g.write(str(traceback.format_exc())+'\n\n')
            g.write("-"*100)

def fun_sources(i):
    global latest_news_file
    try:
        source_name = latest_news_file.at[i,'name']
        os.system(f'python3 content_extractor.py {source_name}')        
    except Exception as exp:
        with open(f'error_sources.txt','a+') as g:
            g.write(source_name+'\n')
            g.write(str(traceback.format_exc())+'\n\n')
            g.write("-"*100)





with concurrent.futures.ProcessPoolExecutor(max_workers=8) as executor:
    results = executor.map(fun_sitemap, latest_news_file.index[0:])
    for result in results:
        latest_news_file.at[result[0],'timestamp'] = str(result[1])

print("Executing After all.")
latest_news_file.to_csv("latest_news.csv",index=False)


with concurrent.futures.ProcessPoolExecutor(max_workers=8) as executor:
    results = executor.map(fun_sources, latest_news_file.index[0:])
    for result in results:
        print(result)